#!/bin/sh
		#################################################
		#	This script is distributed under	#
		#	the terms of the GPL license, visit:	#
		#	http://www.gnu.org/copyleft/gpl.html	#
		#	for details.				#
		#################################################


		#################################################
		#	Author: Abdul Pallares Calvi		#
		#	e-mail: abdul@riereta.net		#
		#################################################


		#################################################
		#	Script to update client's modules	#
		#	   from the scripts repository		#
		#################################################



			#### Global variables ###
if [ -f ../generic/global.conf ]; then
	. ../generic/global.conf
elif [ -f ./generic/global.conf ]; then
	. ./generic/global.conf
else
	echo "ERROR: generic/global.conf doesn't exists. Run \"cvs :pserver:anonymous@sun04:/scripts checkout generic\" in the scripts folder to solve the problem."
	exit 1
fi

			#### Local variables ###
#Format del cron: minuts(0-59) hores(0-23) "dia del mes"(0-31) mes(1-12) "dia de la setmana"(0-7, 0 i 7 son diumenge)
#For disable the automatic adition of this script into cron comment out this line
#CRONDEF="00 1 * * * sh $SCRIPTS/generic/updater.sh"

hostname=`hostname`
MAXBACKUPS=5
if [ -d /tmp ]; then
	TMPDIR=/tmp
elif [ -d /var/tmp ]; then
	TMPDIR=/var/tmp
else
	TMPDIR=/
fi
    ### Include local variables' file.It can  overwrite all previous ones ###
if [ -f $0.conf ];then
	. $0.conf
fi

curscriptdir=`pwd`
cd $SCRIPTS
if [ -d generic ];then
	generic_result=`cvs -d $PSERVER update -CRd generic`
else
	generic_result=`cvs -d $PSERVER checkout generic`
fi

if [ -d $hostname ];then
	hostname_result=`cvs -d $PSERVER update -CRd ${hostname}`
else
	hostname_result=`cvs -d $PSERVER checkout ${hostname}`
fi
cd $curscriptdir
rm $TMPDIR/crontab.*
crontab -l > $TMPDIR/crontab.old
crontab -l > $HOME/crontab.backup.`date +%d_%h_%Y-%H-%M`
for file in `find ${SCRIPTS} -type f | xargs -i grep -l \^[\^#]*CRONDEF= {} | grep -v .#`
do
	# In the next line the * are swapped with % becouse in
	# other way bash interpret them and fails the asignation
	newcron=`grep CRONDEF ${file}`
	newcron='"'`grep CRONDEF ${file} | cut -d\" -f2 | perl -e '$_=<>; $scripts="'${SCRIPTS}'"; $_=~s/\\$SCRIPTS/$scripts/; print $_;'`'"'
	if [ "$newcron" != "" ];then
		filename=
		syscron=

		filename=`perl -e '@a=split("/","'${file}'"); print pop(@a);'`
		syscron=`crontab -l | grep -i ${filename} | perl -e '$_=<>; $_=~s/\s+/\ /g; print $_;'`
		newcron=`perl -e '$_='"${newcron}"'; $_=~s/\s+/\ /g; $_=~s/"//g; print "$_";'`
		if [ "${syscron}" != "${newcron}" ];then
			if `crontab -l | grep -i ${filename} > /dev/null`; then
				cat $TMPDIR/crontab.old
				newcron=`perl -e '$_="'"${newcron}"'"; $_=~s/\s+/\ /g; $_=~s/\//\\\\\//g; print $_;'`
				sed -e 's/^.*'${filename}'.*$/'"${newcron}"'/' $TMPDIR/crontab.old > $TMPDIR/crontab.tmp
				mv $TMPDIR/crontab.tmp $TMPDIR/crontab.old
				cat $TMPDIR/crontab.old
			else
				echo "${newcron}" >> $TMPDIR/crontab.old
			fi
		fi
	fi
	sed -e 's/^[^#]*CRONDEF=/#CRONDEF=/' $file > $TMPDIR/$filename
	mv $TMPDIR/$filename $file
	chmod o+x $file
done
crontab $TMPDIR/crontab.old
totalbackups=`ls -1 $HOME/crontab.backup* | wc -l`
if [ $totalbackups -gt $MAXBACKUPS ]; then
	backupstoremove=`expr $totalbackups - $MAXBACKUPS`
	ls -1ct $HOME/crontab.backup* | tail -$backupstoremove | xargs -i rm {}
fi
