#!/bin/sh
		#################################################
		#	This script is distributed under	#
		#	the terms of the GPL license, visit:	#
		#	http://www.gnu.org/copyleft/gpl.html	#
		#	for details.				#
		#################################################


		#################################################
		#	Author: Abdul Pallares Calvi		#
		#	e-mail: abdul@riereta.net		#
		#################################################


		#################################################
		#	Script to remove modules to the		#
		#		scripts reposoty		#
		#################################################

if [ $# -lt 2 ]; then
	echo Usage: ${0} \"module file/s to remove\"
	exit 1
fi

			#### Global variables ###
if [ -f ../generic/global.conf ]; then
	. ../generic/global.conf
elif [ -f ./generic/global.conf ]; then
	. ./generic/global.conf
else
	echo "ERROR: generic/global.conf doesn't exists. Run \"cvs :pserver:anonymous@sun04:/scripts checkout generic\" in the scripts folder to solve the problem."
	exit 1
fi

if [ ! -d $SCRIPTS/$1/CVS ]; then
	cd $SCRIPTS
	cvs -d $PSERVER checkout $1
fi

cd ${SCRIPTS}/${1}
params=`echo ${*} | sed "s/$1//"`

dir=${SCRIPTS}/${1}.backup_`date +%d-%m-%Y`
mkdir ${dir}
backupok=0
if [ -d ${dir} ];then
	cp ${params} ${dir}/ 
	if [ $? -ne 0 ]; then
		cont=n
		echo ATTENTION: the backup creation failed.
		echo This script will do an rm -f ${params}.
		echo If you want to preserve the files ${params} 
		echo do not continue with the process.
		echo "Do you want to continue the execution of this script? y/n [n]"
		read cont
		if [ "${cont}" != "y" ]; then
			exit 0
		fi
	else
		backupok=1
	fi
else
	cont=n
	echo ATTENTION: the backup creation failed.
	echo This script will do an rm -f ${params}.
	echo If you want to preserve the files: ${params}
	echo do not continue with the process.
	echo "Do you want to continue the execution of this script? y/n [n]"
	read cont
	if [ ${cont} -ne 'y' ]; then
		exit 0
	fi
fi

cvs -d  ${PSERVER} remove -f ${params}
cvs commit -F ${SCRIPTS}/generic/default_action

if [ ${backupok} -eq 1 ]; then
	echo There is a backup of files: ${params} in the folder ${dir}
fi
