#!/bin/sh
		#################################################
		#	This script is distributed under	#
		#	the terms of the GPL license, visit:	#
		#	http://www.gnu.org/copyleft/gpl.html	#
		#	for details.				#
		#################################################


		#################################################
		#	Author: Abdul Pallares Calvi		#
		#	e-mail: abdul@riereta.net		#
		#################################################


		#################################################
		#	Script to remove modules to the		#
		#		scripts reposoty		#
		#################################################

if [ -z ${1} ]; then
	echo Usage: ${0} \"modulename to remove\"
	exit 1
fi

			#### Global variables ###
if [ -f ../generic/global.conf ]; then
	. ../generic/global.conf
elif [ -f ./generic/global.conf ]; then
	. ./generic/global.conf
else
	echo "ERROR: generic/global.conf doesn't exists. Run \"cvs :pserver:anonymous@sun04:/scripts checkout generic\" in the scripts folder to solve the problem."
	exit 1
fi

if [ ! -d $SCRIPTS/$1/CVS ]; then
	cd $SCRIPTS
	cvs -d $PSERVER checkout $1
fi

cd ${SCRIPTS}

dir=${1}.backup_`date +%d-%m-%Y`
cp -r ${1} ${dir} 
backupok=0
if [ $? -ne 0 ]; then
	cont=n
	echo ATTENTION: the backup creation failed.
	echo This script will do an rm -f ${1}.
	echo If you want to preserve the content of the ${1} folder
	echo do not continue with the process.
	echo "Do you want to continue the execution of this script? y/n [n]"
	read cont
	if [ ${cont} -ne 'y' ]; then
		exit 0
	fi
else
	backupok=1
fi

cvs -d  ${PSERVER} remove -fR ${1}
cvs -d ${PSERVER} commit -F ${SCRIPTS}/generic/default_action ${1}
rm -r ${1}

if [ ${backupok} -eq 1 ]; then
	echo The folder ${1} is backed up to ${dir}
	rm -r ${dir}/CVS
fi
